from subprocess import Popen
from clyde import Command
from ..task import Task
from ..var import Var


class CommandTask(Task):

    # Public

    def meta_invoke(self, *args, **kwargs):
        command = Command(*args, **kwargs)
        process = command(operator=Popen, shell=True)
        returncode = process.wait()
        if returncode != 0:
            raise RuntimeError(
                'Command "{command}" exited with "{returncode}"'.
                format(command=command, returncode=returncode))

    @property
    def meta_docstring(self):
        return self._meta_params.get(
            'docstring', 'Execute shell command.')


class CommandVar(Var, CommandTask): pass